"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("@babel/types");
function isDynamicRequire(node) {
    return (node.type === 'CallExpression' &&
        node.callee.type === 'Identifier' &&
        node.callee.name === 'require' &&
        (node.arguments.length !== 1 || node.arguments[0].type !== 'StringLiteral'));
}
module.exports = () => ({
    name: 'replace-dynamic-requires',
    visitor: {
        CallExpression(path) {
            path.node;
            if (!isDynamicRequire(path.node)) {
                return;
            }
            path.replaceWith(types_1.identifier('triggerDynamicRequireError'));
        },
    },
});
//# sourceMappingURL=dynamic-requires.js.map